(* sast.mli -- Semanitcally Checked and Typed Abstract Syntax Tree *)

open Ast

(* Expressions *)
type sexpr = 
  ExprType of expr * data_type

type  sinit =
  SInit of init              

type sstmt = 
    SBlock of sstmt list
  | SExpr of sexpr     									(*foo = bar + 3; *)
  | SReturn of sexpr									(* return 42 also includes return function_name *)
  | SPrint of sexpr 
  | SIf of sexpr * sstmt * sstmt 					(* if (foo == 42) {} else {} *)
  | SFor of sexpr * sexpr * sexpr * sstmt 	(* for loop *)
  | SWhile of sexpr * sstmt 							(* while (i<10) { i = i + 1 } *)
  | SNoElseMark												(* For loops without else*)
  | SVarDecl of sinit
  | SDraw of sexpr

type sfunc_decl = {
    sreturn : data_type;
		sfname : string; 				
		sformals : varSig list; 	(* Formal arguments, type & names *)
		sbody : sstmt;
}

(* Bascially, the parts of a program *)
type sconstruct = 
    SGlobalVar of sinit
  | SFuncDef of sfunc_decl

type sprogram = sconstruct list (* global vars, funcs *)
